function [DD,ni,weiV,iV,indGS] = LaplacianOperator2D_1D(u)
%keyboard
dim = length(u);

% Get dimension-wise Laplacian operators
for i=1:dim
    if i<=2
        ek{i} = ones(u(i),1);
        Dk{i} = spdiags([ek{i} -2*ek{i} ek{i}], [-1 0 1], u(i),u(i));
        Dk{i}(1,1) = -1; Dk{i}(end,end) = -1;
        Ik{i} = speye(u(i));
    else
        ek{i} = ones(u(i),1);
        Dk{i} = 0*spdiags([ek{i} -2*ek{i} ek{i}], [-1 0 1], u(i),u(i));
        Dk{i}(1,1) = 0; Dk{i}(end,end) = 0;
        Ik{i} = speye(u(i));
    end
    
end
% Compute multidimensional Laplacian operator using Kronecker products
for i = 1:dim
    if i ==1; A=Dk{1};else; A=Ik{1};end
    for j = 2:dim
        if j==i;B=Dk{j};else;B=Ik{j};end
        A = kron(B,A); % A x B
    end
    Di{i}=A;
end
Dt = Di{1};for i =2:dim;Dt = Dt+Di{i};end
DD{1} =  Dt'*Dt;

for i=1:dim
    if i>2
        ek{i} = ones(u(i),1);
        Dk{i} = spdiags([ek{i} -2*ek{i} ek{i}], [-1 0 1], u(i),u(i));
        Dk{i}(1,1) = -1; Dk{i}(end,end) = -1;
        Ik{i} = speye(u(i));
    else
        ek{i} = ones(u(i),1);
        Dk{i} = 0*spdiags([ek{i} -2*ek{i} ek{i}], [-1 0 1], u(i),u(i));
        Dk{i}(1,1) = 0; Dk{i}(end,end) = 0;
        Ik{i} = speye(u(i));
    end
    
end
% Compute multidimensional Laplacian operator using Kronecker products
for i = 1:dim
    if i ==1; A=Dk{1};else; A=Ik{1};end
    for j = 2:dim
        if j==i;B=Dk{j};else;B=Ik{j};end
        A = kron(B,A); % A x B
    end
    Di{i}=A;
end
Dt = Di{1};for i =2:dim;Dt = Dt+Di{i};end
DD{2} =  Dt'*Dt;



deg = 2;
inc = [-deg:deg]; linc = length(inc);
% deg0 = deg;
% deg = 4;
% Get independent groups for the GS
if dim >1
    cube = reshape(1:(deg+1)^dim,(deg+1)*ones(1,dim)); indup = repmat(cube,ceil(u/(deg+1)));
else
    cube = 1:(deg+1)^dim; indup = repmat(cube,1,ceil(u(1)/(deg+1)));
end
for i=1:dim; index{i} = 1:u(i);end;ind = indup(index{:});
vind = ind(:);
for i=1:max(ind(:))
    indGS{i} = (find(vind==i));%for kN=1:length(indNaN); %indGS{i}(find(indGS{i}==indNaN(kN)))=[];end
end
% keyboard


% deg = deg0;
for i=1:dim
    delta(:,i) = repmat((reshape(repmat(inc,linc^(i-1),1),[],1)),linc^(dim-i),1);
    if dim >1
        v = ones(1,dim); v(i) = u(i);
        w = u; w(i) = 1; n = ones(v);
        n(:)=1:u(i);K{i} = repmat(n,w);
    else
        K{i} = 1:u(i);
    end
end
ndelta = (sum(abs(delta),2));idOK = find((ndelta<=deg)&(ndelta>0));
deltaOK = delta(idOK,:);


% Get neighbor indexes

if dim>1
    kM = reshape(1:prod(u),u);
else
    kM = (1:u(1))';
end

for k = 1:length(deltaOK)
    iVM{k} = kM+sum(deltaOK(k,:).*cumprod([1 u(1:end-1)]));
    for i=1:dim
        iNaN = (K{i}+deltaOK(k,i)>u(i))|(K{i}+deltaOK(k,i)<1);iVM{k}(iNaN)=NaN;
    end
end


for i=1:length(iVM);iV(i,:) = iVM{i}(:);end
iVV = iV+(prod(u)*ones(size(iV,1),1))*(0:prod(u)-1);
iNaN = isnan(iVV);iVV(iNaN) = prod(u);


for i=1:2
%fDD = full(DD{i});
weiV{i} = bsxfun(@times,-DD{i}(iVV'),1);
ni{i} = diag(DD{i});
end

iNaN=isnan(iV);
iV(iNaN)=1;
iV = iV';

%sum(weiV,2);% Should be equal to one 1 !



end