function [ec2,ec20,ec1,ec10] = linfit_cp(param_data,weighted)
%
% function [ec2,ec20,ec1,ec10] = linfit_cp(param_data,weighted)
% 
% computes linear regression based estimates of c2 and c1 for dataset
% preprocessed by "preproc_data_mvmfa.m"
%
% INPUT
% - param_data  :   structure with parameters and means/variances of log-leaders produced by "preproc_data_mvmfa.m"
% - weighted    :   unweighted (0) or weighted (1) linear regressions
%
% OUTPUT
% - ec2 (ec20)  :   estimates of parameter c2 (and linear regression intercepts)
% - ec1 (ec10)  :   estimates of parameter c1 (and linear regression intercepts)

if nargin<2; weighted=0; end
[ec2,ec20] = regr_cp(param_data.V,param_data.j1,param_data.j2,param_data.Nj(:,2)',weighted,param_data.u);
if nargout>2; [ec1,ec10] = regr_cp(param_data.mV,param_data.j1,param_data.j2,param_data.Nj(:,2)',weighted,param_data.u); end