
function [pL] = pLLc_prior(LLc,j1,j2,Nj,ind0, U, varargin)
%function [pL] = pLLc_prior(LLc,j1,j2,Nj,ind0, U, varargin)
%function [pL] = pLLc_prior(LLc,j1,j2,Nj,ind0, U, Nbi, Nmc, hpGMRF, rmMean,nanIP,MEMSAVE,aSAR)
%valstrs={'Nbi','Nmc','hpGMRF','rmMean','nanIP','MEMSAVE','aSAR'};

van=varargin; 
try clear varargin; van{1}{1}; varargin=van{1}; catch varargin=van; end
clear van;


valstrs={'Nbi','Nmc','hpGMRF','rmMean','nanIP','MEMSAVE','aSAR','NIScale','PostVal'};
vnames={'Nbi','Nmc','hpGMRF','rmMean','nanIP','MEMSAVE','aSAR','NII','POSTEST'};
strs=varargin(1:2:end);vals=varargin(2:2:end);
if ~isempty(vals)
    for k=1:length(strs)
        id=find(strcmp(valstrs,strs{k}));
        if isempty(id);
            disp(['Warning (in pLLc_prior.m): Input argument "',strs{k},'" not recognized']);
        else
            eval([vnames{id},'=vals{k};']);
        end
    end
end

J = j1:j2;
nj  = sqrt(prod(Nj,2)); n0 = length(J);


X(1:n0,1) = nj(j1:j2); X(1:n0,2)= log(2)*J'.*nj(j1:j2);
indM = find(-LLc(1,:)<0);
eps = 10^(-5); eps = 10^(-3.5);%eps = 0;
m  = min(-LLc(2,indM)./(-LLc(1,indM)))-eps;

% Non-zero frequency
LLcNZ = LLc; LLcNZ(:,ind0) = [];
fi  = -LLcNZ(1,:);
gi = LLcNZ(2,:);
Fi  = (m*fi+gi)/m;
Gi  = gi/m;


% Separate zero frequency and non zero ones
LLcZ = LLc(:,ind0);
f0 = -LLcZ(1,:);
g0=LLcZ(2,:);
F0i  = (m*f0+g0)/m;
G0i  = g0/m;

pL.LLc = LLc;
pL.ind0 = ind0;
pL.LLcNZ = LLcNZ;
pL.LLcZ = LLcZ;
pL.Gi = Gi;
pL.Fi = Fi;
pL.G0i = G0i;
pL.F0i = F0i;
pL.m = m;
pL.X = X;

pL.U=U;



% Prior parameters

%pL.param.alpha = 10^-2; pL.param.beta = 10^-2;
pL.param.alpha = 10^-3; pL.param.beta = 10^-3;
%pL.param.alpha = 10^-13; pL.param.beta = 10^-13;

pL.param.w0 = zeros(2,1);
pL.param.D = 10^(5)*[1;1];
%pL.param.D = 10^(10)*[1;1];
pL.param.epi = 0.001*[1 1];

try pL.EST.Nbi=Nbi;
catch pL.EST.Nbi=300; end
try pL.EST.Nmc=Nmc; 
catch pL.EST.Nmc=800; end

try pL.EST.GMRF.a = hpGMRF(1)*ones(1,4);
catch pL.EST.GMRF.a = 8*ones(1,4); end % Spatial
try pL.EST.GMRF.b = hpGMRF(2)*ones(1,2);
catch pL.EST.GMRF.b = 16*ones(1,2); end % Temporal
try pL.EST.GMRF.c = hpGMRF(3)*ones(1,8);
catch pL.EST.GMRF.c = 4*ones(1,8); end % 3D anisotropique

try pL.EST.rmMean=rmMean;   % use a mean-free model for c2 (default: 0)
catch pL.EST.rmMean=0; end
try pL.EST.nanIP=nanIP;    % draw missing data parameters from prior (default: 1)
catch pL.EST.nanIP=1; end
try pL.EST.MEMSAVE=MEMSAVE; % memory efficient computations, not storing chains (default: 1)
catch pL.EST.MEMSAVE=1; end
try pL.EST.epi_SAMP=aSAR;% estimate SAR hyperparameter (default: estimated)
catch pL.EST.epi_SAMP = 1; end
try pL.EST.POSTEST=POSTEST;% output posterior value and MAP (for non-informative / univariate priors)
catch pL.EST.POSTEST = 0; end
end

