function [ec2,CTc2,ec20,Tc20,ec1,Tc1,ec10,Tc10] = pc2BayesDA(y,pL)

MEMSAVE=pL.EST.MEMSAVE;
rmMean=pL.EST.rmMean;
POSTEST=pL.EST.POSTEST;

% u=pL.U.u;
% if numel(u)==1; u=[1 u]; end; urs=u;

u=pL.U.u;
dim = pL.U.dim;
if dim==1; u=max(u); end
urs=u; if numel(urs)==1; urs=[1 urs]; end


Nmc=pL.EST.Nmc;
Nbi=pL.EST.Nbi;



%keyboard
LLc = pL.LLc;
ind0 = pL.ind0; m = pL.m;
X = pL.X;  XX = X'*X;
Fi = pL.Fi; Gi = pL.Gi; iFi = 1./Fi; iGi = 1./Gi;
F0i = pL.F0i; G0i = pL.G0i; iF0i = 1./F0i; iG0i = 1./G0i;
% Priors
alpha = pL.param.alpha; beta = pL.param.beta;
D = pL.param.D; w0 = pL.param.w0;

[yNZ,yZ] = pyNZ_yZ(y,ind0); [M,ny] = size(yNZ); n0 = size(yZ,2);
I   = yNZ.*conj(yNZ); muZ = yZ; muNZ = randn(size(yNZ));

%% MCMC
% Initialization
C2i     = InitC2(LLc,M); 
T1i = -C2i(:,1); T2i = m*C2i(:,2) + C2i(:,1); T1v = T1i; T2v = T2i;
wLS = inv(XX)*(X')*yZ';  wB = wLS; %wB = randn(size(wB));

P = -Inf*ones(M,1);

idn=find(isnan(sum(yZ')));

NNMC=Nmc-Nbi+1;
if MEMSAVE; CTc2.Tc2=[];Tc20=[]; Tc1=[];Tc10=[]; end

if nargout < 5
    
    if POSTEST
        c2MAP = -0.1*ones(M,1); c20MAP = ones(M,1);
    end
    ec2=zeros(M,1);    vc2=zeros(M,1);
    ec20=zeros(M,1);  vc20=zeros(M,1);
    
    for i=1:Nmc
        A = ny+alpha;
        % Hidden mean non zero frequency
        T1Fi = T1v*Fi; T2Gi = T2v*Gi; varGG = 1./(1./T1Fi+1./T2Gi);
%keyboard 
        muG = varGG.*(1./T1Fi.*yNZ);
        muNZ  = muG+sqrt(varGG/2).*(randn(M,ny)+1i*randn(M,ny));
        % v1
        B1 = NormA(yNZ-muNZ,iFi(:))+beta;
        T1v=(1./gamrnd(A,1./B1));
        % v2
        B2 = NormA(muNZ,iGi(:))+beta;
        T2v=(1./gamrnd(A,1./B2));
        if ~MEMSAVE % keep chains
            CTc2.Tc2(:,i) = -T1v; Tc20(:,i)=(T2v+T1v)/m;
        else
            if i > Nbi
                ec2=ec2-T1v/NNMC; ec20=ec20+(T2v+T1v)/m/NNMC;
                vc2=vc2+T1v.^2/NNMC; vc20=vc20+((T2v+T1v)/m).^2/NNMC;
            end
        end
        if POSTEST
            % Compute posterior
            if i > Nbi
                PSDt = [T1v,T2v]*[Fi;Gi];
                Pt  = -(sum(log(PSDt),2)+sum(I./PSDt,2))-(alpha+1)*(log(T1v)+log(T2v))-beta*(1./T1v+1./T2v);
                ind = Pt>P; P(ind)=Pt(ind);
                c2MAP(ind) = -T1v(ind); c20MAP(ind)=(T2v(ind)+T1v(ind))/m;
            end
        end
    end
%     ec2.MAP = c2MAP; ec20.MAP = c20MAP;
    if ~MEMSAVE
        ec2 = mean(CTc2.Tc2(:,Nbi:Nmc),2); ec20 = mean(Tc20(:,Nbi:Nmc),2);
    end
else
    
    if POSTEST
        c2MAP = zeros(M,1); c20MAP = ones(M,1);
        c1MAP = ones(M,1); c10MAP = ones(M,1);
    end

    ec1=zeros(M,1);    vc1=zeros(M,1);
    ec10=zeros(M,1);  vc10=zeros(M,1);
    ec2=zeros(M,1);    vc2=zeros(M,1);
    ec20=zeros(M,1);  vc20=zeros(M,1);
    
    for i=1:Nmc
        
        % Hidden mean non zero frequency
        T1Fi = T1v*Fi; T2Gi = T2v*Gi; varGG = 1./(1./T1Fi+1./T2Gi);
        muG = varGG.*(1./T1Fi).*yNZ;
        muNZ  = muG+sqrt(varGG/2).*(randn(M,ny)+1i*randn(M,ny));
        % Hidden mean zero frequency
        T1F0i = T1v*F0i; T2G0i = T2v*G0i; var0=1./(1./T1F0i+1./T2G0i);
        mu0 = var0.*((1./T1F0i).*yZ+(1./T2G0i).*(X*wB)');
        muZ  = mu0+sqrt(var0).*(randn(M,n0));
        % Mean parameter
        wB = (psamplewB(muZ,T2v*G0i,X,w0,D));
        
        % v1
        if rmMean
            A = ny+alpha;
            B1 = NormA(yNZ-muNZ,iFi(:))+beta;
        else
            A = ny+n0/2+alpha;
            B1 = NormA(yNZ-muNZ,iFi(:))+0.5*NormA(yZ-muZ,iF0i(:))+beta;
        end
        T1v=(1./gamrnd(A,1./B1));
        
        % v2
        if rmMean
            B2 = NormA(muNZ,iGi(:))+beta;
        else
            B2 = NormA(muNZ,iGi(:))+0.5*NormA(muZ-(X*wB)',iG0i(:))+beta;
        end
        T2v=(1./gamrnd(A,1./B2));
        
        if POSTEST
            if i > Nbi
                PSDt = [T1v,T2v]*[Fi;Gi]; PSD0t = [T1v,T2v]*[F0i;G0i];
                Pt  = -(sum(log(PSDt),2)+sum(I./PSDt,2))-0.5*(sum(log(PSD0t),2)+sum(((yZ-(X*wB)').^2)./PSD0t,2))-(alpha+1)*(log(T1v)+log(T2v))-beta*(1./T1v+1./T2v);
                ind = Pt>P; P(ind)=Pt(ind);
                c2MAP(ind) = -T1v(ind); c20MAP(ind)=(T2v(ind)+T1v(ind))/m;
                c1MAP(ind) = wB(2,ind);c10MAP(ind)=wB(1,ind);
            end
        end
        
        % Store
        if ~MEMSAVE
            CTc2.Tc2(:,i) = -T1v;Tc20(:,i)=(T2v+T1v)/m; Tc1(:,i) = wB(2,:);Tc10(:,i) = wB(1,:);
        else
            if i > Nbi
                ec2=ec2-T1v/NNMC; ec20=ec20+(T2v+T1v)/m/NNMC;
                ec1=ec1+wB(2,:)'/NNMC; ec10=ec10+wB(1,:)'/NNMC;
                vc2=vc2+T1v.^2/NNMC; vc20=vc20+((T2v+T1v)/m).^2/NNMC;
                vc1=vc1+(wB(2,:)').^2/NNMC; vc10=vc10+(wB(1,:)').^2/NNMC;
            end
        end
    end
    
    batch = 1;
    if ~MEMSAVE
        ec2 = mean(CTc2.Tc2(:,Nbi:batch:Nmc),2); ec20 = mean(Tc20(:,Nbi:batch:Nmc),2);
        ec1 = mean(Tc1(:,Nbi:batch:Nmc),2); ec10 = mean(Tc10(:,Nbi:batch:Nmc),2);
    end
    % ec2.MAP  = c2MAP; ec1.MAP = c1MAP; ec20.MAP = c20MAP; ec10.MAP = c10MAP;
end

try ec2(idn)=nan; ec2=real(reshape(ec2,urs)); end
try ec20(idn)=nan; ec20=real(reshape(ec20,urs)); end
try ec1(idn)=nan; ec1=real(reshape(ec1,urs)); end
try ec10(idn)=nan; ec10=real(reshape(ec10,urs)); end
try vc2(idn)=nan; vc2=real(reshape(vc2,urs)); end
try vc20(idn)=nan; vc20=real(reshape(vc20,urs)); end
try vc1(idn)=nan; vc1=real(reshape(vc1,urs)); end
try vc10(idn)=nan; vc10=real(reshape(vc10,urs)); end
if MEMSAVE;
    try CTc2.Tc2=vc2-ec2.^2; end
    try Tc20=vc20-ec20.^2; end
    try Tc1=vc1-ec1.^2; end
    try Tc10=vc10-ec10.^2; end
end
if POSTEST
    try c2MAP(idn)=nan; CTc2.c2MAP=real(reshape(c2MAP,urs)); end
    try c20MAP(idn)=nan; CTc2.c20MAP=real(reshape(c20MAP,urs)); end
    try c1MAP(idn)=nan; CTc2.c1MAP=real(reshape(c1MAP,urs)); end
    try c10MAP(idn)=nan; CTc2.c10MAP=real(reshape(c10MAP,urs)); end
    try P(idn)=nan; CTc2.Pt=real(reshape(P,urs)); end
end

%keyboard

end
