function [TS0,pTS,u0] = pcrope_1D(TS,L,dL)
% TS0 row data after cutting
% dL = 0 -> no overlapping
%keyboard
if length(TS)==numel(TS)
    dim = 1; 
    uTS = length(TS);
    %uTS = [1 length(TS)];
else
    uTS = size(TS); dim = length(uTS);
end

%keyboard

switch dim
    case 1 % One single TS
        TS = TS(:)';
        if uTS <= L
            TS0 = TS; pTS = TS; u0 = 1;
            %TS0 = TS; pTS = TS; u0 = [1 1];
        else
            [pTS,b0] = cuteTS(TS,L,dL); TS0 = TS(1:b0);
            %u0 = [size(pTS,1),1];
            %u0 = [1 size(pTS,1)];
            u0 = size(pTS,1);
        end
    case 2 % A sequence of TS
        if uTS(end)<=L
            TS0 = TS; pTS = TS; u0 = uTS(1);
            %TS0 = TS; pTS = TS; u0 = [1 uTS(1)];
        else
            for k = 1:uTS(1);
                [pTS(k,:,:),b0] = cuteTS(TS(k,:),L,dL);
            end
            TS0 = TS(:,1:b0); u0 = size(squeeze(pTS(:,:,1)));
        end
        
    case 3 % A 2D grid of TS
      %  keyboard
        if uTS(end)<=L
            TS0 = TS; pTS = TS; u0 = uTS(1:2);
        else
            for k1 = 1:uTS(1);
                for k2 = 1:uTS(2)
                    [pTS(k1,k2,:,:),b0] = cuteTS(TS(k1,k2,:),L,dL);
                end
            end
            TS0 = TS(:,:,1:b0); u0 = size(squeeze(pTS(:,:,:,1)));
        end
        
    case 4 % A 3D grid of TS
        TS0 = TS; pTS = TS; u0 = size(squeeze(pTS(:,:,:,1)));
        
end

end


function [kpTS,b0] = cuteTS(kTS,L,dL)
kTS = kTS(:)';
Nx = length(kTS);
%rr = L; xx = L-dL;
rr = L; xx = dL;
[XX]=ndgrid( 1:(rr-xx):(Nx-(rr-1)));
IDX1 = (1:rr)';
% offset in indices for each block
offset = (XX(:)-1);
% indices of each block, the block is indexed with the 2rd dimension
IDX = bsxfun(@plus, IDX1, reshape(offset, [1 numel(offset)]));
kpTS =  kTS(IDX)';
%u0 = length(XX);
b0 = [max(XX(:))]+L-1;

end
