function [ec2,Tc2,ec20,Tc20,ec1,Tc1,ec10,Tc10] = pnD_c2GMRF(y,pL,tag)

nanIP=pL.EST.nanIP;
MEMSAVE=pL.EST.MEMSAVE;
rmMean=pL.EST.rmMean;
if nargin < 3  | isempty(tag); 
    if numel(pL.N)==2; tag = '2D+1D'; else; tag = '3D'; end
    %tag = '2D+1D';
end

Nmc = pL.EST.Nmc; Nbi = pL.EST.Nbi;
u=pL.U.u;
dim = pL.U.dim;
if dim==1; u=max(u); end
urs=u; if numel(urs)==1; urs=[1 urs]; end

%keyboard
LLc = pL.LLc;
ind0 = pL.ind0; m = pL.m;
X = pL.X;  XX = X'*X;
Fi = pL.Fi; Gi = pL.Gi; iFi = 1./Fi; iGi = 1./Gi;
F0i = pL.F0i; G0i = pL.G0i; iF0i = 1./F0i; iG0i = 1./G0i;
% Priors
alpha = pL.param.alpha; beta = pL.param.beta;
epi = pL.param.epi;
D = pL.param.D; w0 = pL.param.w0;

[yNZ,yZ] = pyNZ_yZ(y,ind0); ny = size(yNZ,2); n0 = size(yZ,2); M = prod(u);
I   = yNZ.*conj(yNZ); muZ = yZ; muNZ = randn(size(yNZ));

dim = pL.U.dim;

%% MCMC
% Initialization
C2i     = InitC2(LLc,M); T1i = -C2i(:,1); T2i = m*C2i(:,2) + C2i(:,1); T1v = T1i; T2v = T2i;
wLS = inv(XX)*(X')*yZ';  wB = wLS; %wB = randn(size(wB));


T1 = T1i; T2= T2i;

ec2=zeros(M,1); ec20=zeros(M,1); ec1=zeros(M,1); ec10=zeros(M,1);
vc2=zeros(M,1); vc20=zeros(M,1); vc1=zeros(M,1); vc10=zeros(M,1);

NNMC=Nmc-Nbi+1;

switch dim
    case 1
        b = pL.EST.GMRF.b; Z1 = rand(1,1,u-1); Z2 = rand(1,1,u-1);
        if nargout < 5
            for i = 1:Nmc
                A = ny+alpha;
                % Hidden mean non zero frequency
                T1Fi = T1*Fi; T2Gi = T2*Gi; varGG = 1./(1./T1Fi+1./T2Gi);
                muG = varGG.*(1./T1Fi.*yNZ);
                muNZ  = muG+sqrt(varGG/2).*(randn(M,ny)+1i*randn(M,ny));
                % v1
                B1 = NormA(yNZ-muNZ,iFi(:));
                %keyboard
                T1v = sample_IG_2n_0(Z1,b,ny,B1',nanIP); T1 = T1v(:);
                Z1 = sample_G_prior_2n_0(T1v,b);
                
                B2 = NormA(muNZ,iGi(:))+beta;
                T2=(1./gamrnd(A,1./B2));
                % Store
                if ~MEMSAVE
                    Tc2(:,i) = -T1;Tc20(:,i)=(T2+T1)/m;
                else
                    if i > Nbi
                        ec2=ec2-T1/NNMC; ec20=ec20+(T2+T1)/m/NNMC;
                        vc2=vc2+T1.^2/NNMC; vc20=vc20+((T2+T1)/m).^2/NNMC;
                    end
                end
            end
            if ~MEMSAVE
                ec2 = mean(Tc2(:,Nbi:Nmc),2); ec20 = mean(Tc20(:,Nbi:Nmc),2);
            end
        else
            for i=1:Nmc
                A = ny+n0/2+alpha;
                % Hidden mean non zero frequency
                T1Fi = T1*Fi; T2Gi = T2*Gi; varGG = 1./(1./T1Fi+1./T2Gi);
                muG = varGG.*(1./T1Fi).*yNZ;
                muNZ  = muG+sqrt(varGG/2).*(randn(M,ny)+1i*randn(M,ny));
                % Hidden mean zero frequency
                T1F0i = T1*F0i; T2G0i = T2*G0i; var0=1./(1./T1F0i+1./T2G0i);
                mu0 = var0.*((1./T1F0i).*yZ+(1./T2G0i).*(X*wB)');
                muZ  = mu0+sqrt(var0).*(randn(M,n0));
                % Mean parameter
                wB = (psamplewB(muZ,T2*G0i,X,w0,D));
                % v1
                if rmMean;
                    B1 = NormA(yNZ-muNZ,iFi(:));
                    T1v = sample_IG_2n_0(Z1,b,ny,B1',nanIP); T1 = T1v(:);
                else
                    B1 = NormA(yNZ-muNZ,iFi(:)) +0.5*NormA(yZ-muZ,iF0i(:));
                    T1v = sample_IG_2n_0(Z1,b,ny+n0/2,B1',nanIP); T1 = T1v(:);
                end
                Z1 = sample_G_prior_2n_0(T1v,b);
                % v2
                if rmMean;
                    B2 = NormA(muNZ,iGi(:))+beta;
                else
                    B2 = NormA(muNZ,iGi(:))+0.5*NormA(muZ-(X*wB)',iG0i(:))+beta;
                end
                T2=(1./gamrnd(A,1./B2));
                
                % Store
                if ~MEMSAVE
                    Tc2(:,i) = -T1;Tc20(:,i)=(T2+T1)/m; Tc1(:,i) = wB(2,:);Tc10(:,i) = wB(1,:);
                else
                    if i > Nbi
                        ec2=ec2-T1/NNMC; ec20=ec20+(T2+T1)/m/NNMC;
                        ec1=ec1+wB(2,:)'/NNMC; ec10=ec10+wB(1,:)'/NNMC;
                        vc2=vc2+T1.^2/NNMC; vc20=vc20+((T2+T1)/m).^2/NNMC;
                        vc1=vc1+(wB(2,:)').^2/NNMC; vc10=vc10+(wB(1,:)').^2/NNMC;
                    end
                end
            end
            if ~MEMSAVE
                ec2 = mean(Tc2(:,Nbi:Nmc),2); ec20 = mean(Tc20(:,Nbi:Nmc),2);
                ec1 = mean(Tc1(:,Nbi:Nmc),2); ec10 = mean(Tc10(:,Nbi:Nmc),2);
            end
        end
    case 2
        a = pL.EST.GMRF.a; Z1 = rand(u(1)-1,u(2)-1,1); Z2 = rand(u(1)-1,u(2)-1,1);
        if nargout < 5
            for i = 1:Nmc
                A = ny+alpha;
                % Hidden mean non zero frequency
                T1Fi = T1*Fi; T2Gi = T2*Gi; varGG = 1./(1./T1Fi+1./T2Gi);
                muG = varGG.*(1./T1Fi.*yNZ);
                muNZ  = muG+sqrt(varGG/2).*(randn(M,ny)+1i*randn(M,ny));
                % v1
                B1 = NormA(yNZ-muNZ,iFi(:));
                T1v = sample_IG_4n_0(Z1,a,ny,B1',nanIP); T1 = T1v(:);
                Z1 = sample_G_prior_4n_0(T1v,a);
                % v1
                B2 = NormA(muNZ,iGi(:))+beta;
                T2=(1./gamrnd(A,1./B2));
                % Store
                if ~MEMSAVE
                    Tc2(:,i) = -T1;Tc20(:,i)=(T2+T1)/m;
                else
                    if i > Nbi
                        ec2=ec2-T1/NNMC; ec20=ec20+(T2+T1)/m/NNMC;
                        vc2=vc2+T1.^2/NNMC; vc20=vc20+((T2+T1)/m).^2/NNMC;
                    end
                end
            end
            if ~MEMSAVE
                ec2 = mean(Tc2(:,Nbi:Nmc),2); ec20 = mean(Tc20(:,Nbi:Nmc),2);
            end
        else
            for i=1:Nmc
                A = ny+n0/2+alpha;
                % Hidden mean non zero frequency
                T1Fi = T1*Fi; T2Gi = T2*Gi; varGG = 1./(1./T1Fi+1./T2Gi);
                muG = varGG.*(1./T1Fi).*yNZ;
                muNZ  = muG+sqrt(varGG/2).*(randn(M,ny)+1i*randn(M,ny));
                % Hidden mean zero frequency
                T1F0i = T1*F0i; T2G0i = T2*G0i; var0=1./(1./T1F0i+1./T2G0i);
                mu0 = var0.*((1./T1F0i).*yZ+(1./T2G0i).*(X*wB)');
                muZ  = mu0+sqrt(var0).*(randn(M,n0));
                % Mean parameter
                wB = (psamplewB(muZ,T2*G0i,X,w0,D));
                % v1
                if rmMean;
                    B1 = NormA(yNZ-muNZ,iFi(:));
                    T1v = sample_IG_4n_0(Z1,a,ny,B1',nanIP); T1 = T1v(:);
                else
                    B1 = NormA(yNZ-muNZ,iFi(:))+0.5*NormA(yZ-muZ,iF0i(:));
                    T1v = sample_IG_4n_0(Z1,a,ny+n0/2,B1',nanIP); T1 = T1v(:);
                end
                Z1 = sample_G_prior_4n_0(T1v,a);
                % v2
                if rmMean;
                    B2 = NormA(muNZ,iGi(:))+beta;
                else
                    B2 = NormA(muNZ,iGi(:))+0.5*NormA(muZ-(X*wB)',iG0i(:))+beta;
                end
                T2=(1./gamrnd(A,1./B2));
                
                % Store
                if ~MEMSAVE
                    Tc2(:,i) = -T1;Tc20(:,i)=(T2+T1)/m; Tc1(:,i) = wB(2,:);Tc10(:,i) = wB(1,:);
                else
                    if i > Nbi
                        ec2=ec2-T1/NNMC; ec20=ec20+(T2+T1)/m/NNMC;
                        ec1=ec1+wB(2,:)'/NNMC; ec10=ec10+wB(1,:)'/NNMC;
                        vc2=vc2+T1.^2/NNMC; vc20=vc20+((T2+T1)/m).^2/NNMC;
                        vc1=vc1+(wB(2,:)').^2/NNMC; vc10=vc10+(wB(1,:)').^2/NNMC;
                    end
                end
            end
            if ~MEMSAVE
                ec2 = mean(Tc2(:,Nbi:Nmc),2); ec20 = mean(Tc20(:,Nbi:Nmc),2);
                ec1 = mean(Tc1(:,Nbi:Nmc),2); ec10 = mean(Tc10(:,Nbi:Nmc),2);
            end
        end
    case 3
        if strcmp(tag,'2D+1D')
            a = pL.EST.GMRF.a; b=pL.EST.GMRF.b;
            Za1 = rand(u(1)-1,u(2)-1,u(3)); Zb1 = rand(u(1),u(2),u(3)-1);
            Z2 = rand(u(1)-1,u(2)-1,1);
            if nargout < 5
                for i = 1:Nmc
                    A = ny+alpha;
                    % Hidden mean non zero frequency
                    T1Fi = T1*Fi; T2Gi = T2*Gi; varGG = 1./(1./T1Fi+1./T2Gi);
                    muG = varGG.*(1./T1Fi.*yNZ);
                    muNZ  = muG+sqrt(varGG/2).*(randn(M,ny)+1i*randn(M,ny));
                    % v1
                    B1 = NormA(yNZ-muNZ,iFi(:));
                    T1v = sample_IG_6n_0(Za1,a,Zb1,b,ny,B1',nanIP); T1 = T1v(:);
                    [Za1,Zb1] = sample_G_prior_6n_0(T1v,a,b);
                    % v2
                    B2 = NormA(muNZ,iGi(:))+beta;
                    T2=(1./gamrnd(A,1./B2));
                    % Store
                    if ~MEMSAVE
                        Tc2(:,i) = -T1;Tc20(:,i)=(T2+T1)/m;
                    else
                        if i > Nbi
                            ec2=ec2-T1/NNMC; ec20=ec20+(T2+T1)/m/NNMC;
                            vc2=vc2+T1.^2/NNMC; vc20=vc20+((T2+T1)/m).^2/NNMC;
                        end
                    end
                end
                if ~MEMSAVE
                    ec2 = mean(Tc2(:,Nbi:Nmc),2); ec20 = mean(Tc20(:,Nbi:Nmc),2);
                end
            else
                for i=1:Nmc
                    A = ny+n0/2+alpha;
                    % Hidden mean non zero frequency
                    T1Fi = T1*Fi; T2Gi = T2*Gi; varGG = 1./(1./T1Fi+1./T2Gi);
                    muG = varGG.*(1./T1Fi).*yNZ;
                    muNZ  = muG+sqrt(varGG/2).*(randn(M,ny)+1i*randn(M,ny));
                    % Hidden mean zero frequency
                    T1F0i = T1*F0i; T2G0i = T2*G0i; var0=1./(1./T1F0i+1./T2G0i);
                    mu0 = var0.*((1./T1F0i).*yZ+(1./T2G0i).*(X*wB)');
                    muZ  = mu0+sqrt(var0).*(randn(M,n0));
                    % Mean parameter
                    wB = (psamplewB(muZ,T2*G0i,X,w0,D));
                    % v1
                    if rmMean;
                        B1 = NormA(yNZ-muNZ,iFi(:));
                        T1v = sample_IG_6n_0(Za1,a,Zb1,b,ny,B1',nanIP); T1 = T1v(:);
                    else
                        B1 = NormA(yNZ-muNZ,iFi(:))+0.5*NormA(yZ-muZ,iF0i(:));
                        T1v = sample_IG_6n_0(Za1,a,Zb1,b,ny+n0/2,B1',nanIP); T1 = T1v(:);
                    end
                    [Za1,Zb1] = sample_G_prior_6n_0(T1v,a,b);
                    % v2
                    if rmMean;
                        B2 = NormA(muNZ,iGi(:))+beta;
                    else
                        B2 = NormA(muNZ,iGi(:))+0.5*NormA(muZ-(X*wB)',iG0i(:))+beta;
                    end
                    T2=(1./gamrnd(A,1./B2));
                    
                    % Store
                    if ~MEMSAVE
                        Tc2(:,i) = -T1;Tc20(:,i)=(T2+T1)/m;Tc1(:,i) = wB(2,:);Tc10(:,i) = wB(1,:);
                    else
                        if i > Nbi
                            ec2=ec2-T1/NNMC; ec20=ec20+(T2+T1)/m/NNMC;
                            ec1=ec1+wB(2,:)'/NNMC; ec10=ec10+wB(1,:)'/NNMC;
                            vc2=vc2+T1.^2/NNMC; vc20=vc20+((T2+T1)/m).^2/NNMC;
                            vc1=vc1+(wB(2,:)').^2/NNMC; vc10=vc10+(wB(1,:)').^2/NNMC;
                        end
                    end
                end
                if ~MEMSAVE
                    ec2 = mean(Tc2(:,Nbi:Nmc),2); ec20 = mean(Tc20(:,Nbi:Nmc),2);
                    ec1 = mean(Tc1(:,Nbi:Nmc),2); ec10 = mean(Tc10(:,Nbi:Nmc),2);
                end
            end
        elseif   strcmp(tag,'3D')
            c = pL.EST.GMRF.c; Z1 = rand(u(1)-1,u(2)-1,u(3)-1); Z2 = rand(u(1)-1,u(2)-1,1);
            if nargout < 5
                for i = 1:Nmc
                    A = ny+alpha;
                    % Hidden mean non zero frequency
                    T1Fi = T1*Fi; T2Gi = T2*Gi; varGG = 1./(1./T1Fi+1./T2Gi);
                    muG = varGG.*(1./T1Fi.*yNZ);
                    muNZ  = muG+sqrt(varGG/2).*(randn(M,ny)+1i*randn(M,ny));
                    % v1
                    B1 = NormA(yNZ-muNZ,iFi(:));
                    T1v = sample_IG_8n_0(Z1,c,ny,B1',nanIP); 
                    Z1 = sample_G_prior_8n_0(T1v,c);
                    T1 = T1v(:);
                    % v2
                    B2 = NormA(muNZ,iGi(:))+beta;
                    T2=(1./gamrnd(A,1./B2));
                    % Store
                    if ~MEMSAVE
                        Tc2(:,i) = -T1;Tc20(:,i)=(T2+T1)/m;
                    else
                        if i > Nbi
                            ec2=ec2-T1/NNMC; ec20=ec20+(T2+T1)/m/NNMC;
                            vc2=vc2+T1.^2/NNMC; vc20=vc20+((T2+T1)/m).^2/NNMC;
                        end
                    end
                end
                if ~MEMSAVE
                    ec2 = mean(Tc2(:,Nbi:Nmc),2); ec20 = mean(Tc20(:,Nbi:Nmc),2);
                end
            else
                for i=1:Nmc
                    A = ny+n0/2+alpha;
                    % Hidden mean non zero frequency
                    T1Fi = T1*Fi; T2Gi = T2*Gi; varGG = 1./(1./T1Fi+1./T2Gi);
                    muG = varGG.*(1./T1Fi).*yNZ;
                    muNZ  = muG+sqrt(varGG/2).*(randn(M,ny)+1i*randn(M,ny));
                    % Hidden mean zero frequency
                    T1F0i = T1*F0i; T2G0i = T2*G0i; var0=1./(1./T1F0i+1./T2G0i);
                    mu0 = var0.*((1./T1F0i).*yZ+(1./T2G0i).*(X*wB)');
                    muZ  = mu0+sqrt(var0).*(randn(M,n0));
                    % Mean parameter
                    wB = (psamplewB(muZ,T2*G0i,X,w0,D));
                    % v1
                    if rmMean;
                        B1 = NormA(yNZ-muNZ,iFi(:));
                        T1v = sample_IG_8n_0(Z1,c,ny,B1',nanIP);
                    else
                        B1 = NormA(yNZ-muNZ,iFi(:))+0.5*NormA(yZ-muZ,iF0i(:));
                        T1v = sample_IG_8n_0(Z1,c,ny+n0/2,B1',nanIP); T1 = T1v(:);
                    end
                    Z1 = sample_G_prior_8n_0(T1v,c);
                    % v2
                    if rmMean;
                        B2 = NormA(muNZ,iGi(:))+beta;
                    else
                        B2 = NormA(muNZ,iGi(:))+0.5*NormA(muZ-(X*wB)',iG0i(:))+beta;
                    end
                    T2=(1./gamrnd(A,1./B2));
                    
                    % Store
                    if ~MEMSAVE
                        Tc2(:,i) = -T1;Tc20(:,i)=(T2+T1)/m;Tc1(:,i) = wB(2,:);Tc10(:,i) = wB(1,:);
                    else
                        if i > Nbi
                            ec2=ec2-T1/NNMC; ec20=ec20+(T2+T1)/m/NNMC;
                            ec1=ec1+wB(2,:)'/NNMC; ec10=ec10+wB(1,:)'/NNMC;
                            vc2=vc2+T1.^2/NNMC; vc20=vc20+((T2+T1)/m).^2/NNMC;
                            vc1=vc1+(wB(2,:)').^2/NNMC; vc10=vc10+(wB(1,:)').^2/NNMC;
                        end
                    end
                end
                if ~MEMSAVE
                    ec2 = mean(Tc2(:,Nbi:Nmc),2); ec20 = mean(Tc20(:,Nbi:Nmc),2);
                    ec1 = mean(Tc1(:,Nbi:Nmc),2); ec10 = mean(Tc10(:,Nbi:Nmc),2);
                end
            end
            
        end
end

try ec2=real(reshape(ec2,urs)); end
try ec20=real(reshape(ec20,urs)); end
try ec1=real(reshape(ec1,urs)); end
try ec10=real(reshape(ec10,urs)); end

idn=find(isnan(sum(yZ')));
try vc2(idn)=nan; vc2=real(reshape(vc2,urs)); end
try vc20(idn)=nan; vc20=real(reshape(vc20,urs)); end
try vc1(idn)=nan; vc1=real(reshape(vc1,urs)); end
try vc10(idn)=nan; vc10=real(reshape(vc10,urs)); end

if MEMSAVE;
    try Tc2=vc2-ec2.^2; end
    try Tc20=vc20-ec20.^2; end
    try Tc1=vc1-ec1.^2; end
    try Tc10=vc10-ec10.^2; end
end


end






