function [ec2,Tc2,ec20,Tc20,ec1,Tc1,ec10,Tc10,epc1,Tepc1,Tepc10] = pnD_c2GMRF_c1SAR(y,pL,tag)

nanIP=pL.EST.nanIP;
MEMSAVE=pL.EST.MEMSAVE;
rmMean=pL.EST.rmMean;
if nargin < 3 | isempty(tag); 
    %tag = '2D+1D';
    if numel(pL.N)==2; tag = '2D+1D'; else; tag = '3D'; end
end

Nmc = pL.EST.Nmc; Nbi = pL.EST.Nbi;

u=pL.U.u;
dim = pL.U.dim;
if dim==1; u=max(u); end
urs=u; if numel(urs)==1; urs=[1 urs]; end
%keyboard

LLc = pL.LLc;
ind0 = pL.ind0; m = pL.m;
X = pL.X;  XX = X'*X;
Fi = pL.Fi; Gi = pL.Gi; iFi = 1./Fi; iGi = 1./Gi;
F0i = pL.F0i; G0i = pL.G0i; iF0i = 1./F0i; iG0i = 1./G0i;
% Priors
alpha = pL.param.alpha; beta = pL.param.beta;
D = pL.param.D; w0 = pL.param.w0;

[yNZ,yZ] = pyNZ_yZ(y,ind0); ny = size(yNZ,2); n0 = size(yZ,2); M = prod(u);
I   = yNZ.*conj(yNZ); muZ = yZ; muNZ = randn(size(yNZ));

[DD,ni,weiV,iV,ind] = LaplacianOperator(u,tag);

% detect nans
valsy=~isnan(abs(sum(y,2))); % data without nan
nvalsy=find(~valsy); % data with nan id

for ki = 1:length(DD);
    Epi{ki} = pL.param.epi;
    if length(DD{ki})>2000; rM(ki) = length(DD{ki}); else; rM(ki) = rank(full(DD{ki})); end
end

%% MCMC
% Initialization
C2i     = InitC2(LLc,M); 
T1i = -C2i(:,1); T2i = m*C2i(:,2) + C2i(:,1); T1v = T1i; T2v = T2i;
wLS = inv(XX)*(X')*yZ';  
wB = wLS; %wB = randn(size(wB));
iN = isnan(wB(1,:)); 
wB(:,iN) = nanmean(wB,2)*ones(1,sum(iN));

T1 = T1i; T2= T2i;

ec2=zeros(M,1);
ec20=zeros(M,1);
ec1=zeros(M,1);
ec10=zeros(M,1);
vc2=zeros(M,1);
vc20=zeros(M,1);
vc1=zeros(M,1);
vc10=zeros(M,1);
epc1.MMSE=zeros(length(DD),1);
vpc1.MMSE=zeros(length(DD),1);

NNMC=Nmc-Nbi+1;


% % detect nans
% switch dim
%     case 1
%         wV=weiV{1}~=0;  % non-zero weights
%         Val=(valsy + sum(valsy(iV).*wV,2))>0 % non-nan data or data with not only nan in their neighborhood     
%         iVal=find(Val); inVal=find(~Val);
% end
% wB(:,inVal) = nan;

switch dim
    case 1
        b = pL.EST.GMRF.b; Z1 = rand(1,1,u-1); Z2 = rand(1,1,u-1);
        for i=1:Nmc
            % Hidden mean non zero frequency
            T1Fi = T1*Fi; T2Gi = T2*Gi; varGG = 1./(1./T1Fi+1./T2Gi);
            muG = varGG.*(1./T1Fi).*yNZ;
            muNZ  = muG+sqrt(varGG/2).*(randn(M,ny)+1i*randn(M,ny));
            % Hidden mean zero frequency
            T1F0i = T1*F0i; T2G0i = T2*G0i; var0=1./(1./T1F0i+1./T2G0i);
            mu0 = var0.*((1./T1F0i).*yZ+(1./T2G0i).*(X*wB)');
            muZ  = mu0+sqrt(var0).*(randn(M,n0));
            idS = 0;
            for ki = 1:length(DD)
                idS = idS+ bsxfun(@times,ni{ki},1./Epi{ki});
            end
            dS = 1./idS;
            wB = psamplewBSAR_(muZ,T2*G0i,X,dS,wB,ind,iV,weiV,Epi);
            % hyperparam
            if pL.EST.epi_SAMP
                for ki = 1:length(DD)
                    b1 = 0.5*wB(1,:)*DD{ki}*wB(1,:)'; a1 = rM(ki)/2;
                    Epi{ki}(1) = 1/gamrnd(a1,1/b1,1);
                    b2 = 0.5*wB(2,:)*DD{ki}*wB(2,:)'; a2 = rM(ki)/2;
                    Epi{ki}(2) = 1/gamrnd(a2,1/b2,1);
                    Epi{ki}=max(Epi{ki},1e-12);
                end
            end
            % v1
            if rmMean
                A = ny+alpha;
                B1 = NormA(yNZ-muNZ,iFi(:));
                T1v = sample_IG_2n_0(Z1,b,ny,B1',nanIP); T1 = T1v(:);
            else
                A = ny+n0/2+alpha;
                B1 = NormA(yNZ-muNZ,iFi(:))+0.5*NormA(yZ-muZ,iF0i(:));
                T1v = sample_IG_2n_0(Z1,b,ny+n0/2,B1',nanIP); T1 = T1v(:);
            end
            Z1 = sample_G_prior_2n_0(T1v,b);
            % v2
            if rmMean
                B2 = NormA(muNZ,iGi(:))+beta;
            else
                B2 = NormA(muNZ,iGi(:))+0.5*NormA(muZ-(X*wB)',iG0i(:))+beta;
            end
            T2=(1./gamrnd(A,1./B2));

            if ~MEMSAVE
                Tc2(:,i) = -T1;Tc20(:,i)=(T2+T1)/m; Tc1(:,i) = wB(2,:);Tc10(:,i) = wB(1,:);
                for ki=1:length(DD); Tepc1{ki}(i) = Epi{ki}(1); Tepc10{ki}(i) = Epi{ki}(2); end; 
            else
                if i > Nbi
                    ec2=ec2-T1/NNMC; ec20=ec20+(T2+T1)/m/NNMC;
                    ec1=ec1+wB(2,:)'/NNMC; ec10=ec10+wB(1,:)'/NNMC;
                    vc2=vc2+T1.^2/NNMC; vc20=vc20+((T2+T1)/m).^2/NNMC;
                    vc1=vc1+(wB(2,:)').^2/NNMC; vc10=vc10+(wB(1,:)').^2/NNMC;
                    for ki=1:length(DD); 
                        epc1.MMSE(ki) = epc1.MMSE(ki) + Epi{ki}(1)/NNMC ; 
                        vpc1.MMSE(ki) = vpc1.MMSE(ki) + Epi{ki}(1).^2/NNMC ; 
                    end
                end
            end
                
        end
        if ~MEMSAVE
            ec2 = mean(Tc2(:,Nbi:Nmc),2); ec20 = mean(Tc20(:,Nbi:Nmc),2);
            ec1 = mean(Tc1(:,Nbi:Nmc),2); ec10 = mean(Tc10(:,Nbi:Nmc),2);
            for ki=1:length(DD); epc1.MMSE(ki)  = mean(Tepc1{ki}(Nbi:Nmc)); end
        end
        
    case 2
        a = pL.EST.GMRF.a; Z1 = rand(u(1)-1,u(2)-1,1);
        
        for i=1:Nmc
            % Hidden mean non zero frequency
            T1Fi = T1*Fi; T2Gi = T2*Gi; varGG = 1./(1./T1Fi+1./T2Gi);
            muG = varGG.*(1./T1Fi).*yNZ;
            muNZ  = muG+sqrt(varGG/2).*(randn(M,ny)+1i*randn(M,ny));
            % Hidden mean zero frequency
            T1F0i = T1*F0i; T2G0i = T2*G0i; var0=1./(1./T1F0i+1./T2G0i);
            mu0 = var0.*((1./T1F0i).*yZ+(1./T2G0i).*(X*wB)');
            muZ  = mu0+sqrt(var0).*(randn(M,n0));
            % Mean parameter
            idS = 0;
            for ki = 1:length(DD)
                idS = idS+ bsxfun(@times,ni{ki},1./Epi{ki});
            end
            dS = 1./idS;
            wB = psamplewBSAR_(muZ,[T1,T2]*[F0i;G0i],X,dS,wB,ind,iV,weiV,Epi);
            % hyperparam
            if pL.EST.epi_SAMP
                for ki = 1:length(DD)
                    b1 = 0.5*wB(1,:)*DD{ki}*wB(1,:)'; a1 = rM(ki)/2;
                    Epi{ki}(1) = 1/gamrnd(a1,1/b1,1);
                    b2 = 0.5*wB(2,:)*DD{ki}*wB(2,:)'; a2 = rM(ki)/2;
                    Epi{ki}(2) = 1/gamrnd(a2,1/b2,1);
                    Epi{ki}=max(Epi{ki},1e-12);
                end
            end
            % v1
            if rmMean
                A = ny+alpha;
                B1 = NormA(yNZ-muNZ,iFi(:));
                T1v = sample_IG_4n_0(Z1,a,ny,B1',nanIP); T1 = T1v(:);
            else
                A = ny+n0/2+alpha;
                B1 = NormA(yNZ-muNZ,iFi(:))+0.5*NormA(yZ-muZ,iF0i(:));
                T1v = sample_IG_4n_0(Z1,a,ny+n0/2,B1',nanIP); T1 = T1v(:);
            end
            Z1 = sample_G_prior_4n_0(T1v,a);
            % v2
            if rmMean
                B2 = NormA(muNZ,iGi(:))+beta;
            else
                B2 = NormA(muNZ,iGi(:))+0.5*NormA(muZ-(X*wB)',iG0i(:))+beta;
            end
            T2=(1./gamrnd(A,1./B2));
            
            if ~MEMSAVE
                    Tc2(:,i) = -T1;Tc20(:,i)=(T2+T1)/m;
                    Tc1(:,i) = wB(2,:);Tc10(:,i) = wB(1,:);
                    for ki=1:length(DD); Tepc1{ki}(i) = Epi{ki}(1); Tepc10{ki}(i) = Epi{ki}(2); end; 
                else
                    if i > Nbi
                        ec2=ec2-T1/NNMC; ec20=ec20+(T2+T1)/m/NNMC;
                        ec1=ec1+wB(2,:)'/NNMC; ec10=ec10+wB(1,:)'/NNMC;
                        vc2=vc2+T1.^2/NNMC; vc20=vc20+((T2+T1)/m).^2/NNMC;
                        vc1=vc1+(wB(2,:)').^2/NNMC; vc10=vc10+(wB(1,:)').^2/NNMC;
                        for ki=1:length(DD); 
                            epc1.MMSE(ki) = epc1.MMSE(ki) + Epi{ki}(1)/NNMC ; 
                            vpc1.MMSE(ki) = vpc1.MMSE(ki) + Epi{ki}(1).^2/NNMC ; 
                        end
                    end
            end
        end
        if ~MEMSAVE
            ec2 = mean(Tc2(:,Nbi:Nmc),2); ec20 = mean(Tc20(:,Nbi:Nmc),2);
            ec1 = mean(Tc1(:,Nbi:Nmc),2); ec10 = mean(Tc10(:,Nbi:Nmc),2);
            for ki=1:length(DD); epc1.MMSE(ki)  = mean(Tepc1{ki}(Nbi:Nmc)); end
        end
    case 3
        if strcmp(tag,'2D+1D')
            a = pL.EST.GMRF.a; b = pL.EST.GMRF.b;
            Za1 = rand(u(1)-1,u(2)-1,u(3)); Zb1 = rand(u(1),u(2),u(3)-1);
            
            for i=1:Nmc
                % Hidden mean non zero frequency
                T1Fi = T1*Fi; T2Gi = T2*Gi; varGG = 1./(1./T1Fi+1./T2Gi);
                muG = varGG.*(1./T1Fi).*yNZ;
                muNZ  = muG+sqrt(varGG/2).*(randn(M,ny)+1i*randn(M,ny));
                % Hidden mean zero frequency
                T1F0i = T1*F0i; T2G0i = T2*G0i; var0=1./(1./T1F0i+1./T2G0i);
                mu0 = var0.*((1./T1F0i).*yZ+(1./T2G0i).*(X*wB)');
                muZ  = mu0+sqrt(var0).*(randn(M,n0));
                idS = 0;
                for ki = 1:length(DD)
                    idS = idS+ bsxfun(@times,ni{ki},1./Epi{ki});
                end
                dS = 1./idS;
                wB = psamplewBSAR_(muZ,[T1,T2]*[F0i;G0i],X,dS,wB,ind,iV,weiV,Epi);
                % hyperparam
                if pL.EST.epi_SAMP
                    for ki = 1:length(DD)
                        b1 = 0.5*wB(1,:)*DD{ki}*wB(1,:)'; a1 = rM(ki)/2;
                        Epi{ki}(1) = 1/gamrnd(a1,1/b1,1);
                        b2 = 0.5*wB(2,:)*DD{ki}*wB(2,:)'; a2 = rM(ki)/2;
                        Epi{ki}(2) = 1/gamrnd(a2,1/b2,1);
                        Epi{ki}=max(Epi{ki},1e-12);
                    end
                end
                % v1
                if rmMean
                    A = ny+alpha;
                    B1 = NormA(yNZ-muNZ,iFi(:));
                    T1v = sample_IG_6n_0(Za1,a,Zb1,b,ny,B1',nanIP); T1 = T1v(:);
                else
                    A = ny+n0/2+alpha;
                    B1 = NormA(yNZ-muNZ,iFi(:))+0.5*NormA(yZ-muZ,iF0i(:));
                    T1v = sample_IG_6n_0(Za1,a,Zb1,b,ny+n0/2,B1',nanIP); T1 = T1v(:);
                end
                [Za1,Zb1] = sample_G_prior_6n_0(T1v,a,b);
                % v2
                if rmMean
                    B2 = NormA(muNZ,iGi(:))+beta;
                else
                    B2 = NormA(muNZ,iGi(:))+0.5*NormA(muZ-(X*wB)',iG0i(:))+beta;
                end
                T2=(1./gamrnd(A,1./B2));

                if ~MEMSAVE
                    Tc2(:,i) = -T1;Tc20(:,i)=(T2+T1)/m;
                    Tc1(:,i) = wB(2,:);Tc10(:,i) = wB(1,:);
                    for ki=1:length(DD); Tepc1{ki}(i) = Epi{ki}(1); Tepc10{ki}(i) = Epi{ki}(2); end;
                else
                    if i > Nbi
                        ec2=ec2-T1/NNMC; ec20=ec20+(T2+T1)/m/NNMC;
                        ec1=ec1+wB(2,:)'/NNMC; ec10=ec10+wB(1,:)'/NNMC;
                        vc2=vc2+T1.^2/NNMC; vc20=vc20+((T2+T1)/m).^2/NNMC;
                        vc1=vc1+(wB(2,:)').^2/NNMC; vc10=vc10+(wB(1,:)').^2/NNMC;
                        for ki=1:length(DD); 
                            epc1.MMSE(ki) = epc1.MMSE(ki) + Epi{ki}(1)/NNMC ; 
                            vpc1.MMSE(ki) = vpc1.MMSE(ki) + Epi{ki}(1).^2/NNMC ; 
                        end
                    end
                end
            end
            if ~MEMSAVE
                ec2 = mean(Tc2(:,Nbi:Nmc),2); ec20 = mean(Tc20(:,Nbi:Nmc),2);
                ec1 = mean(Tc1(:,Nbi:Nmc),2); ec10 = mean(Tc10(:,Nbi:Nmc),2);
                for ki=1:length(DD); epc1.MMSE(ki)  = mean(Tepc1{ki}(Nbi:Nmc)); end
            end
        elseif strcmp(tag,'3D');
            c = pL.EST.GMRF.c; Z1 = rand(u(1)-1,u(2)-1,u(3)-1);
            
            for i=1:Nmc
                % Hidden mean non zero frequency
                T1Fi = T1*Fi; T2Gi = T2*Gi; varGG = 1./(1./T1Fi+1./T2Gi);
                muG = varGG.*(1./T1Fi).*yNZ;
                muNZ  = muG+sqrt(varGG/2).*(randn(M,ny)+1i*randn(M,ny));
                % Hidden mean zero frequency
                T1F0i = T1*F0i; T2G0i = T2*G0i; var0=1./(1./T1F0i+1./T2G0i);
                mu0 = var0.*((1./T1F0i).*yZ+(1./T2G0i).*(X*wB)');
                muZ  = mu0+sqrt(var0).*(randn(M,n0));
                % Mean parameter
                idS = 0;
                for ki = 1:length(DD)
                    idS = idS+ bsxfun(@times,ni{ki},1./Epi{ki});
                end
                dS = 1./idS;
                wB = psamplewBSAR_(muZ,[T1,T2]*[F0i;G0i],X,dS,wB,ind,iV,weiV,Epi);
                % hyperparam
                if pL.EST.epi_SAMP
                    for ki = 1:length(DD)
                        b1 = 0.5*wB(1,:)*DD{ki}*wB(1,:)'; a1 = rM(ki)/2;
                        Epi{ki}(1) = 1/gamrnd(a1,1/b1,1);
                        b2 = 0.5*wB(2,:)*DD{ki}*wB(2,:)'; a2 = rM(ki)/2;
                        Epi{ki}(2) = 1/gamrnd(a2,1/b2,1);
                        Epi{ki}=max(Epi{ki},1e-12);
                    end
                end
                % v1
                if rmMean
                    A = ny+alpha;
                    B1 = NormA(yNZ-muNZ,iFi(:));
                    T1v = sample_IG_8n_0(Z1,c,ny,B1',nanIP); T1 = T1v(:);
                else
                    A = ny+n0/2+alpha;
                    B1 = NormA(yNZ-muNZ,iFi(:))+0.5*NormA(yZ-muZ,iF0i(:));
                    T1v = sample_IG_8n_0(Z1,c,ny+n0/2,B1',nanIP); T1 = T1v(:);
                end
                Z1 = sample_G_prior_8n_0(T1v,c);
                % v2
                if rmMean
                    B2 = NormA(muNZ,iGi(:))+beta;
                else
                    B2 = NormA(muNZ,iGi(:))+0.5*NormA(muZ-(X*wB)',iG0i(:))+beta;
                end
                T2=(1./gamrnd(A,1./B2));

                if ~MEMSAVE
                    Tc2(:,i) = -T1;Tc20(:,i)=(T2+T1)/m;
                    Tc1(:,i) = wB(2,:);Tc10(:,i) = wB(1,:);
                    for ki=1:length(DD); Tepc1{ki}(i) = Epi{ki}(1); Tepc10{ki}(i) = Epi{ki}(2); end;
                else
                    if i > Nbi
                        ec2=ec2-T1/NNMC; ec20=ec20+(T2+T1)/m/NNMC;
                        ec1=ec1+wB(2,:)'/NNMC; ec10=ec10+wB(1,:)'/NNMC;
                        vc2=vc2+T1.^2/NNMC; vc20=vc20+((T2+T1)/m).^2/NNMC;
                        vc1=vc1+(wB(2,:)').^2/NNMC; vc10=vc10+(wB(1,:)').^2/NNMC;
                        for ki=1:length(DD); 
                            epc1.MMSE(ki) = epc1.MMSE(ki) + Epi{ki}(1)/NNMC ; 
                            vpc1.MMSE(ki) = vpc1.MMSE(ki) + Epi{ki}(1).^2/NNMC ; 
                        end
                    end
                end
            end
            if ~MEMSAVE
                ec2 = mean(Tc2(:,Nbi:Nmc),2); ec20 = mean(Tc20(:,Nbi:Nmc),2);
                ec1 = mean(Tc1(:,Nbi:Nmc),2); ec10 = mean(Tc10(:,Nbi:Nmc),2);
                for ki=1:length(DD); epc1.MMSE(ki)  = mean(Tepc1{ki}(Nbi:Nmc)); end
            end
        end
end

if ~nanIP
    ec1(nvalsy)=nan;ec10(nvalsy)=nan;
    ec2(nvalsy)=nan;ec20(nvalsy)=nan;
    try 
        vc1(nvalsy)=nan;vc10(nvalsy)=nan;
        vc2(nvalsy)=nan;vc20(nvalsy)=nan;
    end
end

try ec2=real(reshape(ec2,urs)); end
try ec20=real(reshape(ec20,urs)); end
try ec1=real(reshape(ec1,urs)); end
try ec10=real(reshape(ec10,urs)); end

try vc2=real(reshape(vc2,urs)); end
try vc20=real(reshape(vc20,urs)); end
try vc1=real(reshape(vc1,urs)); end
try vc10=real(reshape(vc10,urs)); end

if MEMSAVE;
    try Tc2=vc2-ec2.^2; end
    try Tc20=vc20-ec20.^2; end
    try Tc1=vc1-ec1.^2; end
    try Tc10=vc10-ec10.^2; end
    try Tepc1{1}=vpc1.MMSE-epc1.MMSE.^2; end
end

end






