%function wB = psamplewBSAR(wB,v,cB,ni,wLS,ind,iV,weiV,XX,tXX,DD,doC)
function wB = psamplewBSAR_(y0,dD,X,dS,wB,ind,iV,weiV,Epi)
%keyboard
%keyboard
iN = isnan(y0(:,1));
y0(iN,:)=0;
dD(iN,:)=Inf;

%keyboard
% Parallel sampling of  2 x M vectors wB, where each wB(:,m)
% is distributed according to the Gaussian conditional posterior
% N( (X'*D^-1*X + S^-1)^-1*(X'*D^-1*y0 + S^-1*w0) , (X'D^-1+S^-1)^-1 )
%  induced by
% - a Gaussian likelihood exp(-0.5*(y0-Xw)'*D^-1*(y0-Xw))
% - a Gaussian prior exp(-0.5*(w-w0)*S^-1*(w-w0))
% with
% - y0 a N x M
% - D a N x N diagonal matrix diag(dD)
% - X a 2 x 2 design matrix
% - w0 a 2 x 1 mean vector
% - S a 2 x 2 !! diagonal !! covariance matrix
%
% Notations
% - A = X'*D^-1*X
% - B = (X'*D^-1*X+S^-1)^-1
% - C Cholesky decomposition of B
% - mwB = (X'*D^-1*X + S^-1)^-1*(X'*D^-1*y0 + S^-1*w0)
%W0 = bsxfun(@times,iCB12*w0,ni(ind{i})');

for i=randperm(length(ind))
 % keyboard
    wB1=wB(1,:); wB2=wB(2,:);
    w0 = zeros(size(wB(:,ind{i})));
    for ki=1:length(Epi)
        w0(1,:) = w0(1,:)+(dS(ind{i},1).*nansum(wB1(iV(ind{i},:)).*weiV{ki}(ind{i},:),2)/Epi{ki}(1))';
        w0(2,:) = w0(2,:)+(dS(ind{i},2).*nansum(wB2(iV(ind{i},:)).*weiV{ki}(ind{i},:),2)/Epi{ki}(2))';
    end
    
    
    wB(:,ind{i}) = psamplewB(y0(ind{i},:),dD(ind{i},:),X,w0,dS(ind{i},:)');
    
    clear w0
end

end
% Update c

%b = 0.001+0.5*diag( wB*DD*wB');a = 0.001+N/2;
% cB = 1./gamrnd(a,1./b);
% cB(1) = 1./gamrnd(a1,1./b1);
%cB(2) = 1./gamrnd(a2,1./b2);
